<template>
  <div class="dataset-contact">
    <img
      v-if="contact.position > 1"
      class="delete-icon"
      src="@/assets/icons/trash_delete.svg"
      alt="Icône poubelle"
      @click.stop="$emit('delete', contact.position)"
    />
    <form>
      <div class="form-row">
        <div class="form-group col-5">
          <label class="required">Nom</label>
          <ValidationProvider
            v-slot="{ classes, errors }"
            name="Nom contact"
            rules="required"
          >
            <input
              v-model="formData.name"
              :class="classes"
              class="form-control"
              type="text"
              placeholder="Nom"
              @blur="handleBlur"
            >
            <span class="form-errors">{{ errors[0] }}</span>
          </ValidationProvider>
        </div>
        <div class="form-group col-6">
          <label class="required">E-mail</label>
          <ValidationProvider
            v-slot="{ classes, errors }"
            name="Email contact"
            rules="required|email"
          >
            <input
              v-model="formData.email"
              :class="classes"
              class="control form-control"
              type="text"
              placeholder="Adresse e-mail"
              @blur="handleBlur"
            >
            <span class="form-errors">{{ errors[0] }}</span>
          </ValidationProvider>
        </div>
      </div>
    </form>
  </div>
</template>

<script>
import { ValidationProvider, extend, configure, setInteractionMode } from 'vee-validate';
import { required, email } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
extend('email', {
  ...email,
  message: 'Veuillez entrer une adresse e-mail valide'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});
setInteractionMode('passive');

export default {
  name: 'DatasetContactForm',

  components: {
    ValidationProvider
  },

  props: {
    contact: {
      type: Object,
      default: () => {
        return {
          name: null,
          email: null
        }
      }
    }
  },

  data() {
    return {
      formData: {
        name: null,
        email: null
      }
    };
  },

  watch: {
    formData: {
      deep: true,
      handler(newValue) {
        if (newValue) {
          this.$emit('change', {
            ...this.contact.id && { id: this.contact.id },
            name: this.formData.name,
            email: this.formData.email,
            position: this.contact.position,
            role: this.contact.role,
            usergroup: this.contact.usergroup
          })
        }
      }
    }
  },

  created() {
    this.formData.name = this.contact.name;
    this.formData.email = this.contact.email;
  },

  methods: {
    handleBlur() {
      if (this.formData.name !== null && this.formData.email !== null) {
        this.$emit('allowAdd', true);
      } else {
        this.$emit('allowAdd', false);
      }
    }
  }
}
</script>

<style lang="less" scoped>

.dataset-contact {
  position: relative;
  box-shadow: 0 0 2px @blue;
  .delete-icon {
    cursor: pointer;
    position: absolute;
    top: 12%;
    left: calc(99% - 2em);
    width: 1.5em;
  }
  .delete-icon:hover {
    width: 2.2em;
    top: calc(5% - 0.1em);
    left: calc(99% - 2.1em);
  }
}

</style>
